#include <vxWorks.h>
#include <taskLib.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>
#include <semLib.h>

#include "cadef.h"
#include "caerr.h"
#include "caeventmask.h"
#include "task_params.h"
#include "alarm.h"

LOCAL void eventCallback(struct event_handler_args arg)
{
    int			caStatus = arg.status;
    READONLY struct dbr_sts_double *pdata = arg.dbr;

	if(caStatus!=ECA_NORMAL) {
	    printf("eventCallback error %s\n",ca_message(caStatus));
	} else {
	    printf("severity %d value %f\n",pdata->severity,pdata->value);
	}
}

int mycatest(void)
{
    STATUS	status;
    chid	chid;

while(1) {
    memShow(0);
    SEVCHK(ca_task_initialize(),"ca_task_initialize");
    SEVCHK(ca_search("mrkREMOTEprotected",&chid),"ca_search");
    /*Note calls eventCallback immediately called for local Pvs*/
    SEVCHK(ca_add_event(DBR_STS_DOUBLE,chid,eventCallback,0,0),"ca_add_event");
    ca_pend_event(2.0);
    SEVCHK(ca_clear_channel(chid),"as ca_clear_channel");
    SEVCHK(ca_task_exit(),"ca_task_exit");
    printf("mycatest returned from ca_task_exit\n");
}
    status = taskDelete(0);
    if(status!=OK) epicsPrintf("as taskDelete error\n");
    return(0);
}
