/*changeLinks.c*/
#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <tsDefs.h>
#include <cadef.h>
#include <dbDefs.h>

typedef struct{
    chid	mychid;
    short	read_access;
    short	write_access;
} MYNODE;

MYNODE *pmynode = NULL;


typedef enum {stateNull,stateMaster,stateClient,statePP}progState;
main(int argc,char **argv)
{
    int		npv;
    MYNODE	*pnode;
    int		status;
    int		i;
    int		option;
    progState	state;
    char	name[40];
    int		sleeptime;

    if(argc!=4) {
	printf("usage: changeLinks <nrecords> <sleep> <0=null,1=server,2=client,3=pp,4=cont>\n");
	exit(1);
    }
    sscanf(argv[1],"%d",&npv);
    sscanf(argv[2],"%d",&sleeptime);
    sscanf(argv[3],"%d",&option);
    pmynode = (MYNODE *)calloc(npv,sizeof(MYNODE));
    for(i=0; i<npv; i++) {
	memset((char *)&pmynode[i],0,sizeof(MYNODE));
    }
    SEVCHK(ca_task_initialize(),"ca_task_initialize");
    for(i=0; i<npv; i++) {
	sprintf(name,"mrkMasterAiFromMaster%04.4d.INP",i);
	SEVCHK(ca_search_and_connect(name,&pmynode[i].mychid,
		NULL,0),
		"ca_search_and_connect");
    }
    ca_pend_io(0.0);
    if(option==4) state=stateNull; else state = option;
    while(TRUE) {
#if 0
printf("state %d press return to continue\n",state);
fgets(name,10,stdin);
#endif
	for(i=0; i<npv; i++) {
	    if(ca_state(pmynode[i].mychid) !=cs_conn) continue;
	    if(state==stateNull) {
		sprintf(name,"",i);
	    } else if(state==stateMaster) {
		sprintf(name,"mrkMasterCalc%04.4d CP",i);
	    } else if(state==stateClient) {
		sprintf(name,"mrkClient%04.4d CP",i);
	    } else {/*statePP*/
		sprintf(name,"mrkMasterCalc%04.4d PP",i);
	    }
	    status = ca_put(DBR_STRING,pmynode[i].mychid,name);
	    if(status!=ECA_NORMAL)
		printf("%s From ca_put\n",ca_message(status));
	}
	ca_pend_io(0.0);
	if(option!=4) break;
	if(state==statePP) state = stateNull; else state++;
	sleep(sleeptime);
    }
}
