#include <vxWorks.h>
#include <taskLib.h>
#include <string.h>
#include <stdlib.h>
#include <stddef.h>
#include <stdio.h>
#include <semLib.h>

#include "dbDefs.h"
#include "errlog.h"
#include "taskwd.h"
#include "asDbLib.h"
#include "cadef.h"
#include "caerr.h"
#include "caeventmask.h"
#include "task_params.h"
#include "alarm.h"


typedef struct {
    struct dbr_sts_double rtndata;
    chid		chid;
} CAPVT;

/*connectCallback only handles disconnects*/
LOCAL void connectCallback(struct connection_handler_args arg)
{
    chid		chid = arg.chid;

printf("connectCallback for %s\n",ca_name(chid));
    if(ca_state(chid)!=cs_conn) {
	    printf("as connectCallback disconnect %s\n",
		ca_name(chid));
    }
}

LOCAL void eventCallback(struct event_handler_args arg)
{
    chid		chid = arg.chid;
    int			caStatus = arg.status;
    READONLY struct dbr_sts_double *pdata = arg.dbr;

printf("connectCallback for %s\n",ca_name(chid));
    if(ca_state(chid)!=cs_conn || !ca_read_access(chid)) {
	printf("eventCallback %s inpBad ca_state %d"
		       " ca_read_access %d\n",
		    ca_name(chid),ca_state(chid),ca_read_access(chid));
    } else {
	if(caStatus!=ECA_NORMAL) {
	    epicsPrintf("caTemp: eventCallback error %s\n",ca_message(caStatus));
	} else {
	    if(pdata->severity==INVALID_ALARM) {
		    printf("as eventCallback %s inpBad because INVALID_ALARM\n",
		    ca_name(chid));
	    } else {
		    printf("as eventCallback %s inpGood data %f\n",
			ca_name(chid),pdata->value);
	    }
	}
    }
}

int caTemp(void)
{
    CAPVT	capvt;
    CAPVT	*pcapvt = &capvt;
    int		status;

    SEVCHK(ca_task_initialize(),"ca_task_initialize");
	status = ca_search_and_connect(
		    "mrktestLongArray5",&pcapvt->chid,
		    connectCallback,0);
	if(status!=ECA_NORMAL) {
		    epicsPrintf("caTemp ca_search_and_connect error %s\n",
			ca_message(status));
	}
printf("calling ca_add_event for %s\n",ca_name(pcapvt->chid));
	/*Note calls eventCallback immediately  for local Pvs*/
	status = ca_add_event(DBR_STS_DOUBLE,pcapvt->chid,
		    eventCallback,0,0);
	if(status!=ECA_NORMAL) {
		    epicsPrintf("caTemp ca_add_event error %s\n",
			ca_message(status));
	}
	    ca_pend_event(2.0);
	return(0);
}
