#include <vxWorks.h>
#include <semLib.h>
#include <tickLib.h>
#include <dbDefs.h>
#include <stdlib.h>
#include <stddef.h>
#include <string.h>
#include <stdio.h>

volatile int iteration;
#define niterations 1000000
int timeSem()
{
    SEM_ID bsem;
    SEM_ID msem;
    unsigned long stime,etime,i;
    double totalTime,microsecs;

    bsem = semBCreate(SEM_Q_FIFO,SEM_FULL);
    if(!bsem) {
	printf("semBCreate failed\n");
	return(-1);
    }
    msem = semMCreate(SEM_DELETE_SAFE|SEM_INVERSION_SAFE|SEM_Q_PRIORITY);
    if(!msem) {
	printf("semMCreate failed\n");
	return(-1);
    }
    stime = tickGet();
    for(i=0; i<niterations; i++) {
	semTake(bsem,WAIT_FOREVER);
	semGive(bsem);
	semTake(bsem,WAIT_FOREVER);
	semGive(bsem);
	semTake(bsem,WAIT_FOREVER);
	semGive(bsem);
	semTake(bsem,WAIT_FOREVER);
	semGive(bsem);
	semTake(bsem,WAIT_FOREVER);
	semGive(bsem);
    }
    etime=tickGet();
    totalTime=etime-stime;
    totalTime /= 60.0;
    microsecs = 1e6/(niterations*5/totalTime);
    printf("Binary microsecs=%5.1f\n",microsecs);
    stime = tickGet();
    for(i=0; i<niterations; i++) {
	semTake(msem,WAIT_FOREVER);
	semGive(msem);
	semTake(msem,WAIT_FOREVER);
	semGive(msem);
	semTake(msem,WAIT_FOREVER);
	semGive(msem);
	semTake(msem,WAIT_FOREVER);
	semGive(msem);
	semTake(msem,WAIT_FOREVER);
	semGive(msem);
    }
    etime=tickGet();
    totalTime=etime-stime;
    totalTime /= 60.0;
    microsecs = 1e6/(niterations*5/totalTime);
    printf("Binary microsecs=%5.1f\n",microsecs);
    return(0);
}
