/*testputnotify.c*/
#include <stddef.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <cadef.h>
#include <dbDefs.h>

static chid	mychid[20];
static int	ntrys;
static int	gotCallback;

void putCallback(struct event_handler_args args)
{
    gotCallback = TRUE;
    printf("putCallback ");
    if(args.chid) printf(" pv=%s\n",ca_name(args.chid));
    if(args.status!=ECA_NORMAL)
	printf("putCallback %s\n",ca_message(args.status));
}

main(void)
{
    char	line[80];
    char	pvname[50];
    char	value[50];
    int		status,i,len;

    SEVCHK(ca_task_initialize(),"ca_task_initialize");
    for(i=0; i<20; i++) {
	fprintf(stdout,"pvname value: ");
	fflush(stdout);
	fgets(line,80,stdin);
	len = strlen(line);
	if(line[len-1]=='\n')line[len-1] = 0;
	sscanf(line,"%s %s\n",pvname,value);
        status = ca_search(pvname,&mychid[i]);
	if(status!=ECA_NORMAL) {
	    printf("ca_search %s\n",ca_message(status));
	    continue;
	}
	status = ca_pend_io(2.0);
	if(status!=ECA_NORMAL) {
	    printf("ca_pend_io %s\n",ca_message(status));
	    continue;
	}
	status = ca_array_put_callback(DBR_STRING,1,mychid[i],
		(void *)value,putCallback,NULL);
	if(status!=ECA_NORMAL) {
	    printf("ca_array_put_callback %s\n",ca_message(status));
	    continue;
	}
	status = ca_pend_event(5.0);
	if(status!=ECA_NORMAL && status!=ECA_TIMEOUT) {
	    printf("ca_pend_io %s\n",ca_message(status));
	    continue;
	}
	printf("Returned from ca_pend_event\n");
    }
    return(0);
}
