/*testTS.c */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#include "drvTS.h"
#include "tsDefs.h"

#if defined(vxWorks)
#   include <vxWorks.h>
#elif defined(VMS)
#   include <sys/types.h>
#   include <sys/time.h>
#   include <sys/socket.h>
#elif defined(_WIN32)
#   include <windows.h>
#   include <time.h>
#   include <mmsystem.h>
#else
#   include <sys/time.h>
#endif

#  ifndef vxWorks
int  main()
  {
    return testTS();
  }
#  endif
int testTS()
{
    long	stat;
    TS_STAMP	stamp;
    char	stampTxt[32];
    unsigned long secs;
    unsigned long fraction,nsec;

    (void)printf("Getting current date:\n");
    if ((stat = tsLocalTime(&stamp)) != S_ts_OK) {
	(void)printf("%s\n", TsStatusToText(stat));
	return 1;
    }
    (void)printf("	%s\n",
			tsStampToText(&stamp, TS_TEXT_MONDDYYYY, stampTxt));
    (void)printf("	%s\n",
			tsStampToText(&stamp, TS_TEXT_MMDDYY, stampTxt));

    secs = (unsigned long)TS_1900_TO_EPICS_EPOCH;
    printf("TS_1900_TO_EPICS_EPOCH %lu\n",secs);
    secs = (unsigned long)TS_1900_TO_VXWORKS_EPOCH;
    printf("TS_1900_TO_VXWORKS_EPOCH %lu\n",secs);
    secs = (unsigned long)TS_VXWORKS_TO_EPICS_EPOCH;
    printf("TS_VXWORKS_TO_EPICS_EPOCH %lu\n",secs);
    fraction = 0x80000000;
    nsec = TSfractionToNano(fraction);
    printf("fraction %lx is %lu\n",fraction,nsec);
    fraction = 0xc0000000;
    nsec = TSfractionToNano(fraction);
    printf("fraction %lx is %lu\n",fraction,nsec);
    fraction = 0xffffffff;
    nsec = TSfractionToNano(fraction);
    printf("fraction %lx is %lu\n",fraction,nsec);
    return 0;
}
