/*testTime.c */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>

#include "tsDefs.h"

#if defined(vxWorks)
#   include <vxWorks.h>
#elif defined(VMS)
#   include <sys/types.h>
#   include <sys/time.h>
#   include <sys/socket.h>
#elif defined(_WIN32)
#   include <windows.h>
#   include <time.h>
#   include <mmsystem.h>
#else
#   include <sys/time.h>
#endif

#  ifndef vxWorks
int  main()
  {
    return testTime();
  }
#  endif
int testTime()
{
    long	stat;
    double	dbl;
    TS_STAMP	stamp1;
    char	stamp1Txt[32];
    TS_STAMP	stamp2;
    char	stamp2Txt[32];
    TS_STAMP	stamp3;
    char	stamp3Txt[32];
    TS_STAMP	stampD;
    char	stampDTxt[32];
    TS_STAMP	stampDbl;
    char	stampDblTxt[32];
    TS_STAMP	stampDblD;
    char	stampDblDTxt[32];
    TS_STAMP	inStamp;
    char	inStampTxt[80];

/*----------------------------------------------------------------------------
*    get current date and print in the various ways possible
*----------------------------------------------------------------------------*/
    (void)printf("Getting current date:\n");
    if ((stat = tsLocalTime(&stamp1)) != S_ts_OK) {
	(void)printf("%s\n", TsStatusToText(stat));
	return 1;
    }
    (void)printf("	%s\n",
			tsStampToText(&stamp1, TS_TEXT_MONDDYYYY, stamp1Txt));
    (void)printf("	%s\n",
			tsStampToText(&stamp1, TS_TEXT_MMDDYY, stamp1Txt));

/*----------------------------------------------------------------------------
*    now, play around a bit with other routines
*----------------------------------------------------------------------------*/
    stamp2.secPastEpoch = 80432;
    stamp2.nsec = 900000000;

    TsAddStamps(&stamp3, &stamp1, &stamp2);
    (void)printf("%s plus %s is %s\n",
			stamp1Txt,
			tsStampToText(&stamp2, TS_TEXT_MMDDYY, stamp2Txt),
    			tsStampToText(&stamp3, TS_TEXT_MMDDYY, stamp3Txt));
    TsDiffAsStamp(&stampD, &stamp3, &stamp1);
    (void)printf("%s minus %s is %s\n",
			stamp3Txt, stamp1Txt,
    			tsStampToText(&stampD, TS_TEXT_MMDDYY, stampDTxt));
    TsDiffAsDouble(&dbl, &stamp3, &stamp1);
    (void)printf("%s Minus %s is %.9f\n", stamp3Txt, stamp1Txt, dbl);
    TsDiffAsDouble(&dbl, &stamp1, &stamp3);
    (void)printf("%s Minus %s is %.9f\n", stamp1Txt, stamp3Txt, dbl);

    tsAddDouble(&stampDbl, &stamp1, 80432.9);
    (void)printf("%s plus %.9f is %s\n",
			stamp1Txt, 80432.9,
    			tsStampToText(&stampDbl, TS_TEXT_MMDDYY, stampDblTxt));
    TsAddDouble(&stampDbl, &stamp1, 80432.9);
    (void)printf("%s Plus %.9f is %s\n",
			stamp1Txt, 80432.9,
    			tsStampToText(&stampDbl, TS_TEXT_MMDDYY, stampDblTxt));
    tsAddDouble(&stampDblD, &stampDbl, -80432.9);
    (void)printf("%s plus %.9f is %s\n",
			stampDblTxt, -80432.9,
    			tsStampToText(&stampDblD,TS_TEXT_MMDDYY, stampDblDTxt));
    TsAddDouble(&stampDblD, &stampDbl, -80432.9);
    (void)printf("%s Plus %.9f is %s\n",
			stampDblTxt, -80432.9,
    			tsStampToText(&stampDblD,TS_TEXT_MMDDYY, stampDblDTxt));

    stamp2.nsec = 100000000;
    TsAddStamps(&stamp3, &stamp1, &stamp2);
    (void)printf("%s plus %s is %s\n",
			stamp1Txt,
			tsStampToText(&stamp2, TS_TEXT_MMDDYY, stamp2Txt),
    			tsStampToText(&stamp3, TS_TEXT_MMDDYY, stamp3Txt));
    TsDiffAsStamp(&stampD, &stamp3, &stamp1);
    (void)printf("%s minus %s is %s\n",
			stamp3Txt, stamp1Txt,
    			tsStampToText(&stampD, TS_TEXT_MMDDYY, stampDTxt));
    TsDiffAsDouble(&dbl, &stamp3, &stamp1);
    (void)printf("%s Minus %s is %.9f\n", stamp3Txt, stamp1Txt, dbl);
    TsDiffAsDouble(&dbl, &stamp1, &stamp3);
    (void)printf("%s Minus %s is %.9f\n", stamp1Txt, stamp3Txt, dbl);

    tsAddDouble(&stampDbl, &stamp1, 80432.1);
    (void)printf("%s plus %.9f is %s\n",
			stamp1Txt, 80432.1,
    			tsStampToText(&stampDbl, TS_TEXT_MMDDYY, stampDblTxt));
    TsAddDouble(&stampDbl, &stamp1, 80432.1);
    (void)printf("%s Plus %.9f is %s\n",
			stamp1Txt, 80432.1,
    			tsStampToText(&stampDbl, TS_TEXT_MMDDYY, stampDblTxt));
    tsAddDouble(&stampDblD, &stampDbl, -80432.1);
    (void)printf("%s plus %.9f is %s\n",
			stampDblTxt, -80432.1,
    			tsStampToText(&stampDblD,TS_TEXT_MMDDYY, stampDblDTxt));
    TsAddDouble(&stampDblD, &stampDbl, -80432.1);
    (void)printf("%s Plus %.9f is %s\n",
			stampDblTxt, -80432.1,
    			tsStampToText(&stampDblD,TS_TEXT_MMDDYY, stampDblDTxt));

    (void)printf("comparisons for %s vs %s\n", stamp1Txt, stamp3Txt);
    (void)printf("	tsCmpStamps:  A,B %2d    B,A %2d    A,A %2d\n",
	    tsCmpStamps(&stamp1, &stamp3), tsCmpStamps(&stamp3, &stamp1),
	    tsCmpStamps(&stamp1, &stamp1));
    (void)printf(
	"	macro A vs B: EQ %d  NE %d  GT %d  GE %d  LT %d  LE %d\n",
	    TsCmpStampsEQ(&stamp1, &stamp3), TsCmpStampsNE(&stamp1, &stamp3),
	    TsCmpStampsGT(&stamp1, &stamp3), TsCmpStampsGE(&stamp1, &stamp3),
	    TsCmpStampsLT(&stamp1, &stamp3), TsCmpStampsLE(&stamp1, &stamp3));
    (void)printf(
	"	macro B vs A: EQ %d  NE %d  GT %d  GE %d  LT %d  LE %d\n",
	    TsCmpStampsEQ(&stamp3, &stamp1), TsCmpStampsNE(&stamp3, &stamp1),
	    TsCmpStampsGT(&stamp3, &stamp1), TsCmpStampsGE(&stamp3, &stamp1),
	    TsCmpStampsLT(&stamp3, &stamp1), TsCmpStampsLE(&stamp3, &stamp1));
    (void)printf(
	"	macro A vs A: EQ %d  NE %d  GT %d  GE %d  LT %d  LE %d\n",
	    TsCmpStampsEQ(&stamp1, &stamp1), TsCmpStampsNE(&stamp1, &stamp1),
	    TsCmpStampsGT(&stamp1, &stamp1), TsCmpStampsGE(&stamp1, &stamp1),
	    TsCmpStampsLT(&stamp1, &stamp1), TsCmpStampsLE(&stamp1, &stamp1));

    stamp2.secPastEpoch = 0;
    stamp2.nsec = 10000000;
    TsAddStamps(&stamp3, &stamp1, &stamp2);
    (void)printf("comparisons for %s vs %s\n", stamp1Txt,
    			tsStampToText(&stamp3, TS_TEXT_MMDDYY, stamp3Txt));
    (void)printf("	tsCmpStamps:  A,B %2d    B,A %2d    A,A %2d\n",
	    tsCmpStamps(&stamp1, &stamp3), tsCmpStamps(&stamp3, &stamp1),
	    tsCmpStamps(&stamp1, &stamp1));
    (void)printf(
	"	macro A vs B: EQ %d  NE %d  GT %d  GE %d  LT %d  LE %d\n",
	    TsCmpStampsEQ(&stamp1, &stamp3), TsCmpStampsNE(&stamp1, &stamp3),
	    TsCmpStampsGT(&stamp1, &stamp3), TsCmpStampsGE(&stamp1, &stamp3),
	    TsCmpStampsLT(&stamp1, &stamp3), TsCmpStampsLE(&stamp1, &stamp3));
    (void)printf(
	"	macro B vs A: EQ %d  NE %d  GT %d  GE %d  LT %d  LE %d\n",
	    TsCmpStampsEQ(&stamp3, &stamp1), TsCmpStampsNE(&stamp3, &stamp1),
	    TsCmpStampsGT(&stamp3, &stamp1), TsCmpStampsGE(&stamp3, &stamp1),
	    TsCmpStampsLT(&stamp3, &stamp1), TsCmpStampsLE(&stamp3, &stamp1));

/*----------------------------------------------------------------------------
*    exercise tsTextToStamp
*----------------------------------------------------------------------------*/
    inStampTxt[0] = '\0';
    while (strncmp(inStampTxt, "quit", 4) != 0) {
	(void)printf("type text date/time or quit: ");
	if (fgets(inStampTxt, 80, stdin) == NULL) {
	    (void)strcpy(inStampTxt, "quit");
	    (void)printf("\n");
	    clearerr(stdin);
	}
	else if (strncmp(inStampTxt, "quit", 4) == 0)
	    ;		/* no action */
	else {
	    char	*pText;
	    pText = inStampTxt;
	    if ((stat = tsTextToStamp(&inStamp, &pText)) != S_ts_OK) {
		(void)printf("%s\n", TsStatusToText(stat));
	    }
	    else {
		(void)printf("stamp is: %u %u %s\n", inStamp.secPastEpoch,
			inStamp.nsec,
			tsStampToText(&inStamp, TS_TEXT_MONDDYYYY, inStampTxt));
	    }
	}
    }

    inStampTxt[0] = '\0';
    while (strncmp(inStampTxt, "quit", 4) != 0) {
	(void)printf("type text time or quit: ");
	if (fgets(inStampTxt, 80, stdin) == NULL) {
	    (void)strcpy(inStampTxt, "quit");
	    (void)printf("\n");
	    clearerr(stdin);
	}
	else if (strncmp(inStampTxt, "quit", 4) == 0)
	    ;		/* no action */
	else {
	    char	*pText;
	    pText = inStampTxt;
	    if ((stat = tsTimeTextToStamp(&inStamp, &pText)) != S_ts_OK) {
		(void)printf("%s\n", TsStatusToText(stat));
	    }
	    else {
		(void)printf("stamp is: %u %u %s\n", inStamp.secPastEpoch,
			inStamp.nsec,
			tsStampToText(&inStamp, TS_TEXT_MONDDYYYY, inStampTxt));
	    }
	}
    }

    clearerr(stdin);
    return 0;
}
